library("gnlr")
sole <- read.table("sole.dat",skip=5)
names(sole) <- c("sal","temp","h1","t1","h2","t2","h3","t3","h4","t4")
attach(sole)
sal <- rep(sal,4)
temp <- rep(temp,4)
sal2 <- sal^2
temp2 <- temp^2
st <- sal*temp
hatch <- c(h1,h2,h3,h4)
total <- c(t1,t2,t3,t4)
y <- cbind(hatch,total-hatch)
y1 <- cbind(total-hatch,hatch)
mu <- function(p,linear) exp(linear)/(1+exp(linear))
mu2 <- function(p,linear) exp(-exp(linear))
mu3 <- function(p,linear) 1-exp(-exp(linear))

-sum(lchoose(total,hatch)+hatch*log(hatch)+(total-hatch)*log(total-hatch)-total*log(total))
-sum(lchoose(total,hatch)+hatch*log(hatch)+(total-hatch)*log(total-hatch)-total*log(total))+length(total)
p.i <- rep((h1+h2+h3+h4)/(t1+t2+t3+t4),4)
-sum(lchoose(total,hatch)+hatch*log(p.i)+(total-hatch)*log(1-p.i))
-sum(lchoose(total,hatch)+hatch*log(p.i)+(total-hatch)*log(1-p.i))+length(h1)

# untransformed variables

glm(y~sal+sal2+temp+temp2+st,family=binomial)
glm(y1~sal+sal2+temp+temp2+st,family=binomial(link=cloglog))
glm(y~sal+sal2+temp+temp2+st,family=binomial(link=cloglog))

print(z1 <- gnlr(y,p=c(-13,0.4, -0.01, 2.4,-0.15, 0.01),dist="binomial",mu=mu,
	linear=~sal+sal2+temp+temp2+st,stepmx=1))
z1$maxlik-220.353  #1157.439

print(z1a <- gnlr(y,p=c(-7.85,0.215,-0.00552,1.41,-0.089, 0.00734),
	dist="binomial",mu=mu2,linear=~sal+sal2+temp+temp2+st,stepmx=1))
z1a$maxlik-220.353  #1018.939

print(z1b <- gnlr(y,p=c(-8,0.2,-0.00552,1.41,-0.089, 0.00734),
	dist="binomial",mu=mu3,linear=~sal+sal2+temp+temp2+st,stepmx=0.1))
z1b$maxlik-220.353  #1495.358

print(z2 <- gnlr(y,pmu=c(-13,0.4, -0.01, 2.4,-0.15, 0.01),psh=4,
	dist="beta binomial",mu=mu, linear=~sal+sal2+temp+temp2+st,stepmax=1))
z2$maxlik-220.353  #164.6971

print(zdb2 <- gnlr(y,pmu=c(-13.11,0.408,-0.0098,2.411,-0.149,0.0102),psh=0.099,
	dist="double binomial",mu=mu, linear=~sal+sal2+temp+temp2+st,
	print.level=2,iter=20))
z2$maxlik-220.353  #

print(z2a <- gnlr(y,p=c(-7.847,0.215,-0.00552,1.41,-0.089, 0.00734,3),
	dist="beta binomial",mu=mu2,linear=~sal+sal2+temp+temp2+st,stepmx=1))
z2a$maxlik-220.353  #155.0826

print(z2b <- gnlr(y,p=c(-8,0.2,-0.00552,1.41,-0.089, 0.00734,3),
	dist="beta binomial",mu=mu3,linear=~sal+sal2+temp+temp2+st,stepmx=0.1))
z2b$maxlik-220.353  #177.3674

print(z3 <- gnlr(y,p=c(-13,0.4, -0.01, 2.4,-0.15, 0.01,3.8,-0.1,-0.1),
	dist="beta binomial",mu=mu,
	linear=list(~sal+sal2+temp+temp2+st,~sal+sal2),stepmx=1))
z3$maxlik-220.353  #160.3173

print(z3a <- gnlr(y,p=c(-7.847,0.215,-0.00552,1.41,-0.089, 0.00734,3,-0.1,-0.1),
	dist="beta binomial",mu=mu2,
	linear=list(~sal+sal2+temp+temp2+st,~sal+sal2),stepmx=1))
z3a$maxlik-220.353  #149.1452

print(z3b <- gnlr(y,p=c(-8,0.2,-0.00552,1.41,-0.089, 0.00734,3,-0.1,-0.1),
	dist="beta binomial",mu=mu3,
	linear=list(~sal+sal2+temp+temp2+st,~sal+sal2),stepmx=0.5))
z3b$maxlik-220.353  #173.4989

print(z4 <- gnlr(y,p=c(-13,0.4, -0.01, 2.4,-0.15, 0.01,-1,-0.53,0.03),
	dist="beta binomial",mu=mu,
	linear=list(~sal+sal2+temp+temp2+st,~temp+temp2),stepmx=1))
z4$maxlik-220.353  #157.2702

print(z4a <- gnlr(y,p=c(-7.847,0.215,-0.00552,1.41,-0.089, 0.00734,1.5,0,0),
	dist="beta binomial",mu=mu2,
	linear=list(~sal+sal2+temp+temp2+st,~temp+temp2),stepmx=1,itnlim=200))
z4a$maxlik-220.353  #152.7279

print(z4b <- gnlr(y,p=c(-7.847,0.215,-0.00552,1.41,-0.089, 0.00734,1.5,0,0),
	dist="beta binomial",mu=mu3,
	linear=list(~sal+sal2+temp+temp2+st,~temp+temp2),stepmx=1,itnlim=200))
z4b$maxlik-220.353  #164.0395

print(z5 <- gnlr(y,p=c(-10,0.4, -0.01, 2.4,-0.15, 0.01,4,0,0,0,0,0),
	dist="beta binomial",mu=mu,
	linear=list(~sal+sal2+temp+temp2+st,~sal+sal2+temp+temp2+st),stepmx=3))
z5$maxlik-220.353  #150.9975

print(z5a <- gnlr(y,p=c(-7.847,0.215,-0.00552,1.41,-0.089, 0.00734,-1,-1,-0.1,-0.53,0.03,0.2),
	dist="beta binomial",mu=mu2,
	linear=list(~sal+sal2+temp+temp2+st,~sal+sal2+temp+temp2+st),stepmx=1,itnlim=200))
z5a$maxlik-220.353  #148.2165

#-5.7,0.16,-0.0042,1.03,-0.065,0.0057,1.1,0.091,-0.0058,0.05,-0.02,0.023
print(z5b <- gnlr(y,p=c(-6,0.16,-0.0042,1.03,-0.065,0.0057,1,0.091,-0.0058,0.05,-0.02,0.023),
	dist="beta binomial",mu=mu3,
	linear=list(~sal+sal2+temp+temp2+st,~sal+sal2+temp+temp2+st),stepmx=0.1))
z5b$maxlik-220.353  #158.7038

# logit link
p <- z5$coefficients
#probability
fp1 <- function(x1,x2) {
	t<-exp(p[1]+p[2]*x1+p[3]*x1^2+p[4]*x2+p[5]*x2^2+p[6]*x1*x2)
	t/(1+t)}
zz1p <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) {
	x1 <- (i+14)
	x2 <- j/4+3.75
	zz1p[i,j] <- fp1(x1,x2)}
contour((15:40),seq(4,12,by=0.25),zz1p)
title(main="Probability",xlab="Salinity",ylab="Temperature")
fp1(2.5,9)
aa <- -c(p[2],p[4])
bb <- matrix(c(2*p[3],p[6],p[6],2*p[5]),nrow=2)
solve(bb,aa)
range(zz1p)

#dispersion
fd1 <- function(x1,x2)
	exp(p[7]+p[8]*x1+p[9]*x1^2+p[10]*x2+p[11]*x2^2+p[12]*x1*x2)
zz1d <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) {
	x1 <- (i+14)
	x2 <- j/4+3.75
	zz1d[i,j] <- fd1(x1,x2)}
contour((15:40),seq(4,12,by=0.25),zz1d)
title(main="Dispersion",xlab="Salinity",ylab="Temperature")
fd1(2.6,9)
range(zz1d)

#correlation
fc1 <- function(x1,x2)
	1/(1+exp(p[7]+p[8]*x1+p[9]*x1^2+p[10]*x2+p[11]*x2^2+p[12]*x1*x2))
zz1c <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) {
	x1 <- (i+14)
	x2 <- j/4+3.75
	zz1c[i,j] <- fc1(x1,x2)}
contour((15:40),seq(4,12,by=0.25),zz1c)
title(main="Correlation",xlab="Salinity",ylab="Temperature")
fc1(2.6,9)
range(zz1c)

# cloglog link
p <- z5a$coefficients
#probability
fp1a <- function(x1,x2)
	exp(-exp(p[1]+p[2]*x1+p[3]*x1^2+p[4]*x2+p[5]*x2^2+p[6]*x1*x2))
zz1pa <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) {
	x1 <- (i+14)
	x2 <- j/4+3.75
	zz1pa[i,j] <- fp1a(x1,x2)}
contour((15:40),seq(4,12,by=0.25),zz1pa)
title(main="Probability",xlab="Salinity",ylab="Temperature")
fp1a(2.5,9)
aa <- -c(p[2],p[4])
bb <- matrix(c(2*p[3],p[6],p[6],2*p[5]),nrow=2)
solve(bb,aa)
range(zz1pa)

#dispersion
fd1a <- function(x1,x2)
	exp(p[7]+p[8]*x1+p[9]*x1^2+p[10]*x2+p[11]*x2^2+p[12]*x1*x2)
zz1da <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) {
	x1 <- (i+14)
	x2 <- j/4+3.75
	zz1da[i,j] <- fd1a(x1,x2)}
contour((15:40),seq(4,12,by=0.25),zz1da)
title(main="Dispersion",xlab="Salinity",ylab="Temperature")
fd1a(2.6,9)
aa <- -c(p[8],p[10])
bb <- matrix(c(2*p[9],p[12],p[12],2*p[11]),nrow=2)
solve(bb,aa)
range(zz1da)

#correlation
fc1a <- function(x1,x2)
	1/(1+exp(p[7]+p[8]*x1+p[9]*x1^2+p[10]*x2+p[11]*x2^2+p[12]*x1*x2))
zz1ca <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) {
	x1 <- (i+14)
	x2 <- j/4+3.75
	zz1ca[i,j] <- fc1a(x1,x2)}
contour((15:40),seq(4,12,by=0.25),zz1ca)
title(main="Correlation",xlab="Salinity",ylab="Temperature")
fc1a(2.6,9)
range(zz1ca)

#mu <- function(p) {
#	s <- sal^(p[7]/10)
#	t <- temp^(p[8]/10)
#	tt <- p[1]+p[2]*s+p[3]*t+p[4]*s^2+p[5]*t^2+p[6]*s*t
#	exp(tt)/(1+exp(tt))}
#shape <- function(p) p[9]/100
#print(z0t <- gnlr(y,p=c(-22.3,.7,7.6,-.021,-0.092,0.85,7.5,7),dist="binomial",mu=mu))
#c(-22.3,7,7.6,-2.1,-0.92,0.85,750,600)

# transformed variables

s <- sal^0.2
t <- temp^-0.2
s2 <- s^2
t2 <- t^2
stt <- s*t

glm(y~s+s2+t+t2+stt,family=binomial)
glm(y~s+s2+t+t2+stt,family=binomial(link=cloglog)) 

s <- sal^0.2
t <- temp^0.2
s2 <- s^2
t2 <- t^2
stt <- s*t

glm(y~s+s2+t+t2+stt,family=binomial)
glm(y1~s+s2+t+t2+stt,family=binomial(link=cloglog))
glm(y~s+s2+t+t2+stt,family=binomial(link=cloglog)) 

print(z1t <- gnlr(y,p=c(-270,110,-37,234,-88,18),dist="binomial",
	mu=mu,linear=~s+s2+t+t2+stt,stepmx=1))
z1t$maxlik-220.353  #639.9047

print(z1ta <- gnlr(y,p=c(216.1,-92,30,-175,65,-12.3),dist="binomial",
	mu=mu2,linear=~s+s2+t+t2+stt,stepmx=0.1))
z1ta$maxlik-220.353  #553.4468

print(z1tb <- gnlr(y,p=c(-161.75,57,-20,143,-54,12),dist="binomial",
	mu=mu3,linear=~s+s2+t+t2+stt,stepmx=0.1))
z1tb$maxlik-220.353  #893.5642

print(z2t <- gnlr(y,p=c(-270,109.4,-36.9,232.4,-87,18,3.47),
	dist="beta binomial",mu=mu, linear=~s+s2+t+t2+stt,stepmx=0.1))
#steptl=0.00000001,ndigit=12, gradtl=0.0000001))
z2t$maxlik-220.353  #141.7913

print(z2ta <- gnlr(y,p=c(217,-92.21,29.89,-175.13,64.9,-12.31,3.5),
	dist="beta binomial",mu=mu2, linear=~s+s2+t+t2+stt,stepmx=0.05,steptl=0.00000001,ndigit=12, gradtl=0.0000001))
z2ta$maxlik-220.353  #131.0350

print(z2tb <- gnlr(y,p=c(-161.75,57,-20,143,-54,12,2),
	dist="beta binomial",mu=mu3, linear=~s+s2+t+t2+stt,stepmx=0.1))
z2tb$maxlik-220.353  #159.2102

print(z4t <- gnlr(y,p=c(-265.05,107.1,-35.47,220.1,-82.07,16.3,4.01,0.076,-0.0058,0.0252,-0.03,0.0195),
	dist="beta binomial",mu=mu,
	linear=list(~s+s2+t+t2+stt,~sal+sal2+temp+temp2+st),stepmx=0.01,steptl=0.000000001,ndigit=16, gradtl=0.000000001,itnlim=200))
z4t$maxlik-220.353  # 131.4681

print(z4ta <- gnlr(y,p=c(216.3,-90.8,29.2,-176.6,64.9,-11.4,3.3,0.16,-0.003,-0.09,0.008,-0.0045),
	dist="beta binomial",mu=mu2,
	linear=list(~s+s2+t+t2+stt,~sal+sal2+temp+temp2+st),stepmx=0.05,steptl=0.000000001,ndigit=14, gradtl=0.000001))
z4ta$maxlik-220.353  #126.4648

print(z4tb <- gnlr(y,p=c(-161.75,57,-20,143,-54,12,2,0,0,0,0,0),
	dist="beta binomial",mu=mu3,
	linear=list(~s+s2+t+t2+stt,~sal+sal2+temp+temp2+st),stepmx=0.1,steptl=0.000000001,ndigit=14, gradtl=0.000001))
z4tb$maxlik-220.353  #139.5796

print(z5t <- gnlr(y,p=c(-260,106.79,-34.12,221,-80.12,13.058,5.44,-0.219,-1.176,0.36,0.839,0.124),
	dist="beta binomial",mu=mu,
	linear=list(~s+s2+t+t2+stt,~s+s2+t+t2+stt),stepmx=0.1,steptl=0.00000001,ndigit=16, gradtl=0.0000001,itnlim=200))
z5t$maxlik-220.353  #134.8369

print(z5ta <- gnlr(y,p=c(206,-86,28,-168,62,-11.9,3.76,0.02,-0.02,0.02,0.01,-0.001),
	dist="beta binomial",mu=mu2,
	linear=list(~s+s2+t+t2+stt,~s+s2+t+t2+stt),steptl=0.00000001,ndigit=14, gradtl=0.0000001,stepmx=0.01))
z5ta$maxlik-220.353  #130.7997

#-153.9,58.3,-18.4,131,-46.8,6.7,3.43,-0.065,-1.42,0.41,1.65,0.29
print(z5tb <- gnlr(y,p=c(-153.2,58.7,-18.5,129.9,-46.4,6.7,3.94,-0.065,-1.49,0.41,1.51,0.29),
	dist="beta binomial",mu=mu3,
	linear=list(~s+s2+t+t2+stt,~s+s2+t+t2+stt),steptl=0.00000001,ndigit=16,,gradtl=0.0000001,stepmx=0.05,itnlim=200))
z5tb$maxlik-220.353  #142.7728

#p <- z4t$coefficients
p <- z5t$coefficients

aa <- -c(p[2],p[4])
bb <- matrix(c(2*p[3],p[6],p[6],2*p[5]),nrow=2)
solve(bb,aa)^5

#probability
fp2 <- function(x1,x2) {
	t<-exp(p[1]+p[2]*x1^.2+p[3]*x1^.4+p[4]*x2^.2+p[5]*x2^.4+p[6]*x1^.2*x2^.2)
	t/(1+t)}
zz2p <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) zz2p[i,j] <- fp2((i+14),j/4+3.75)
contour((15:40),seq(4,12,by=0.25),zz2p)
title(main="Probability -  Sole (transformed)",xlab="Salinity",ylab="Temperature")
fp2(2.4,8.5)
range(zz2p)

#correlation
fc2 <- function(x1,x2)
	1/(1+exp(p[7]+p[8]*x1^.2+p[9]*x1^.4+p[10]*x2^.2+p[11]*x2^.4+p[12]*x1^.2*x2^.2))
zz2c <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) zz2c[i,j] <- fc2((i+14),j/4+3.75)
contour((15:40),seq(4,12,by=0.25),zz2c)
title(main="Correlation -  Sole (transformed)",xlab="Salinity",ylab="Temperature")
fc2(1.5,7.5)
range(zz2c)

#correlation
#fc2 <- function(x1,x2)
#	1/(1+exp(p[7]+p[8]*x1+p[9]*x1^2+p[10]*x2+p[11]*x2^2+p[12]*x1*x2))
#zz2c <- matrix(nrow=26,ncol=33)
#for (i in 1:26) for (j in 1:33) zz2c[i,j] <- fc2((i+14),j/4+3.75)
#contour((15:40),seq(4,12,by=0.25),zz2c)
#title(main="Correlation -  Sole (transformed)",xlab="Salinity",ylab="Temperature")
#fc2(1.5,7.5)
#range(zz2c)

#postscript(file="/home/jlindsey/texts/articles/fish/sole.eps",landscape=FALSE,height=5)
par(mfcol=c(1,2))
contour((15:40),seq(4,12,by=0.25),zz2p)
title(xlab="Salinity",ylab="Temperature")
contour((15:40),seq(4,12,by=0.25),zz2c)
title(xlab="Salinity",ylab="Temperature")
#x11()

print(z6t <- gnlr(y,p=c(-266.15,107.2,-34.3,221.2,-80.32,13.25,5.5,-0.2,-1.2,0.91,0.129),
	dist="beta binomial",mu=mu,
	linear=list(~s+s2+t+t2+stt,~s+s2+t2+stt),stepmx=0.05,steptl=0.00000001,ndigit=16, gradtl=0.0000001))
z6t$maxlik-220.353  # 134.8536

print(z7t <- gnlr(y,p=c(-266.15,107.2,-34.3,221.2,-80.32,13.25,5.5,-1.2,0.91,0.129),
	dist="beta binomial",mu=mu,
	linear=list(~s+s2+t+t2+stt,~s2+t2+stt),stepmx=0.05,steptl=0.00000001,ndigit=16, gradtl=0.0000001))
z7t$maxlik-220.353  # 134.8561

print(z7ta <- gnlr(y,p=c(206.6,-87.65,28.65,-167.25,62.2,-12.3,3.9,-0.02,0.01,-0.001),
	dist="beta binomial",mu=mu2,
	linear=list(~s+s2+t+t2+stt,~s2+t2+stt),steptl=0.00000001,ndigit=14, gradtl=0.0000001,stepmx=0.01))
z7ta$maxlik-220.353  #130.7546

print(z7tb <- gnlr(y,p=c(-153.2,58.7,-18.5,129.9,-46.4,6.7,3.94,-1.49,1.51,0.29),
	dist="beta binomial",mu=mu3,
	linear=list(~s+s2+t+t2+stt,~s2+t2+stt),steptl=0.00000001,ndigit=16,,gradtl=0.0000001,stepmx=0.05,itnlim=200))
z7tb$maxlik-220.353  #142.8377

print(z8t <- gnlr(y,p=c(-266,107.4,-34.5,220.6,-80.2,13.4,5.5,-1.18,0.85),
	dist="beta binomial",mu=mu,
	linear=list(~s+s2+t+t2+stt,~s2+t2),stepmx=0.05,steptl=0.00000001,ndigit=16, gradtl=0.0000001))
z8t$maxlik-220.353  # 134.9323

print(z8ta <- gnlr(y,p=c(206.7,-87.68,28.66,-167.34,62.2,-12.3,3.87,-0.02,0.01),
	dist="beta binomial",mu=mu2,
	linear=list(~s+s2+t+t2+stt,~s2+t2),steptl=0.00000001,ndigit=14, gradtl=0.0000001,stepmx=0.01))
z8ta$maxlik-220.353  #130.7584

print(z8tb <- gnlr(y,p=c(-153.2,58.7,-18.5,129.9,-46.4,6.7,3.94,-1.49,1.51),
	dist="beta binomial",mu=mu3,
	linear=list(~s+s2+t+t2+stt,~s2+t2),steptl=0.00000001,ndigit=16,,gradtl=0.0000001,stepmx=0.05,itnlim=200))
z8tb$maxlik-220.353  #142.9031

print(z9t <- gnlr(y,p=c(-266,107.4,-34.5,220.6,-80.2,13.4,5.5,-1.18),
	dist="beta binomial",mu=mu,
	linear=list(~s+s2+t+t2+stt,~s2),stepmx=0.05,steptl=0.00000001,ndigit=16, gradtl=0.0000001))
z9t$maxlik-220.353  # 138.1933

print(z9ta <- gnlr(y,p=c(206.7,-87.67,28.65,-167.32,62.2,-12.29,3.9,-0.02),
	dist="beta binomial",mu=mu2,
	linear=list(~s+s2+t+t2+stt,~s2),steptl=0.00000001,ndigit=16, gradtl=0.0000001,stepmx=0.01))
z9ta$maxlik-220.353  #130.7391

print(z9tb <- gnlr(y,p=c(-153.2,58.7,-18.5,129.9,-46.4,6.7,3.94,-1.49),
	dist="beta binomial",mu=mu3,
	linear=list(~s+s2+t+t2+stt,~s2),steptl=0.00000001,ndigit=16,,gradtl=0.0000001,stepmx=0.05,itnlim=200))
z9tb$maxlik-220.353  #142.9031

p <- z7t$coefficients
#probability
fp3 <- function(x1,x2) {
	t<-exp(p[1]+p[2]*x1^.2+p[3]*x1^.4+p[4]*x2^.2+p[5]*x2^.4+p[6]*x1^.2*x2^.2)
	t/(1+t)}
zz3p <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) zz3p[i,j] <- fp3((i+14),j/4+3.75)
contour((15:40),seq(4,12,by=0.25),zz3p)
title(main="Probability -  Sole (transformed)",xlab="Salinity",ylab="Temperature")
fp3(2.4,8.5)
range(zz3p)

#correlation
fc3 <- function(x1,x2)
	1/(1+exp(p[7]+p[8]*x1^.4+p[9]*x2^.4+p[10]*x1^.2*x2^.2))
zz3c <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) zz3c[i,j] <- fc3((i+14),j/4+3.75)
contour((15:40),seq(4,12,by=0.25),zz3c)
title(main="Correlation -  Sole (transformed)",xlab="Salinity",ylab="Temperature")
fc3(1.5,7.5)
range(zz3c)

#postscript(file="/home/jlindsey/texts/articles/fish/sole2a.eps",landscape=FALSE,height=5)
par(mfcol=c(1,2))
contour((15:40),seq(4,12,by=0.25),zz3p)
title(xlab="Salinity",ylab="Temperature")
contour((15:40),seq(4,12,by=0.25),zz3c)
title(xlab="Salinity",ylab="Temperature")
#x11()

print(z10t <- gnlr(y,p=c(-264.9,107,-35.48,220.1,-82.14,16.47,4.12,0.076,-0.0058,-0.029,0.02),
	dist="beta binomial",mu=mu,
	linear=list(~s+s2+t+t2+stt,~sal+sal2+temp2+st),stepmx=0.01,steptl=0.000000001,ndigit=16, gradtl=0.000000001,itnlim=200))
z10t$maxlik-220.353  # 131.5074

print(z10ta <- gnlr(y,p=c(216.3,-90.8,29.2,-176.6,64.9,-11.4,3.3,0.16,-0.003,0.008,-0.0045),
	dist="beta binomial",mu=mu2,
	linear=list(~s+s2+t+t2+stt,~sal+sal2+temp2+st),stepmx=0.05,steptl=0.000000001,ndigit=14, gradtl=0.000001))
z10ta$maxlik-220.353  #127.1815

print(z10tb <- gnlr(y,p=c(-143.5,49.5,-17.6,128.7,-48.6,10.6,2.14,-0.007,-0.038,0.023),
	dist="beta binomial",mu=mu3,
	linear=list(~s+s2+t+t2+stt,~sal2+temp2+st),stepmx=0.1,steptl=0.000000001,ndigit=14, gradtl=0.000001))
z10tb$maxlik-220.353  #139.5796

print(z11t <- gnlr(y,p=c(-264.9,107,-35.48,220.1,-82.14,16.47,4.75,-0.0045,-0.0283,0.021),
	dist="beta binomial",mu=mu,
	linear=list(~s+s2+t+t2+stt,~sal2+temp2+st),stepmx=0.05,steptl=0.000000001,ndigit=16, gradtl=0.000000001,itnlim=200))
z11t$maxlik-220.353  # 131.5017

print(z11ta <- gnlr(y,p=c(206.9,-85.2,27.6,-170.8,62.9,-11.38,2.63,0.14,-0.00353,0.0034),
	dist="beta binomial",mu=mu2,
	linear=list(~s+s2+t+t2+stt,~sal+sal2+temp2),stepmx=0.01,steptl=0.000000001,ndigit=16, gradtl=0.000001))
z11ta$maxlik-220.353  #127.1815

print(z12ta <- gnlr(y,p=c(213.1,-92.4,29.5,-170.2,62.5,-11.2,4.82,0,0,0),
	dist="beta binomial",mu=mu2,
	linear=list(~s+s2+t+t2+stt,~sal2+temp2+st),stepmx=0.01,steptl=0.000000001,ndigit=16, gradtl=0.00000001,itnlim=200))
z12ta$maxlik-220.353  #127.7039

print(z13ta <- gnlr(y,p=c(213.1,-92.4,29.5,-170.2,62.5,-11.2,4.82,0,0),
	dist="beta binomial",mu=mu2,
	linear=list(~s+s2+t+t2+stt,~sal2+temp2),stepmx=0.01,steptl=0.000000001,ndigit=16, gradtl=0.00000001,itnlim=200))
z13ta$maxlik-220.353  #127.7046

print(z14ta <- gnlr(y,p=c(213.1,-92.4,29.5,-170.2,62.5,-11.2,4.82,0),
	dist="beta binomial",mu=mu2,
	linear=list(~s+s2+t+t2+stt,~sal2),stepmx=0.02,steptl=0.000000001,ndigit=16, gradtl=0.00000001,itnlim=200))
z14ta$maxlik-220.353  #127.7046

p <- z11t$coefficients
#probability
fp5 <- function(x1,x2) {
	t<-exp(p[1]+p[2]*x1^.2+p[3]*x1^.4+p[4]*x2^.2+p[5]*x2^.4+p[6]*x1^.2*x2^.2)
	t/(1+t)}
zz5p <- matrix(nrow=31,ncol=33)
for (i in 1:31) for (j in 1:33) zz5p[i,j] <- fp5((i+9),j/4+3.75)
contour((10:40),seq(4,12,by=0.25),zz5p)
points(sal[1:18],temp[1:18],pch=20)
title(main="Probability -  Sole (transformed)",xlab="Salinity",ylab="Temperature")
fp5(2.4,8.5)
range(zz5p)

#correlation
fc5 <- function(x1,x2)
	1/(1+exp(p[7]+p[8]*x1^2+p[9]*x2^2+p[10]*x1*x2))
zz5c <- matrix(nrow=31,ncol=33)
for (i in 1:31) for (j in 1:33) zz5c[i,j] <- fc5((i+9),j/4+3.75)
contour((10:40),seq(4,12,by=0.25),zz5c)
points(sal[1:18],temp[1:18],pch=20)
title(main="Correlation -  Sole (transformed)",xlab="Salinity",ylab="Temperature")
fc5(1.5,7.5)
range(zz5c)

#postscript(file="/home/jlindsey/texts/articles/fish/sole2.eps",landscape=FALSE,height=5)
par(mfcol=c(1,2))
contour((10:40),seq(4,12,by=0.25),zz5p)
points(sal[1:18],temp[1:18],pch=20)
title(xlab="Salinity",ylab="Temperature")
contour((10:40),seq(4,12,by=0.25),zz5c)
points(sal[1:18],temp[1:18],pch=20)
title(xlab="Salinity",ylab="Temperature")
#x11()

p <- z14ta$coefficients
#probability
fp4 <- function(x1,x2)
	t<-exp(-exp(p[1]+p[2]*x1^.2+p[3]*x1^.4+p[4]*x2^.2+p[5]*x2^.4+p[6]*x1^.2*x2^.2))
zz4p <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) zz4p[i,j] <- fp4((i+14),j/4+3.75)
contour((15:40),seq(4,12,by=0.25),zz4p)
title(main="Probability -  Sole (transformed)",xlab="Salinity",ylab="Temperature")
fp4(2.4,8.5)
range(zz4p)

#correlation
fc4 <- function(x1,x2)
	1/(1+exp(p[7]+p[8]*x1^2))
zz4c <- matrix(nrow=26,ncol=33)
for (i in 1:26) for (j in 1:33) zz4c[i,j] <- fc4((i+14),j/4+3.75)
contour((15:40),seq(4,12,by=0.25),zz4c)
title(main="Correlation -  Sole (transformed)",xlab="Salinity",ylab="Temperature")
fc4(20,10)
range(zz4c)

#postscript(file="/home/jlindsey/texts/articles/fish/sole3.eps",landscape=FALSE,height=5)
par(mfcol=c(1,2))
contour((15:40),seq(4,12,by=0.25),zz4p)
title(xlab="Salinity",ylab="Temperature")
contour((15:40),seq(4,12,by=0.25),zz4c)
title(xlab="Salinity",ylab="Temperature")
#x11()
